//#include "Model.h"
class Particle {
private:
	float lifetime;                       // Lifetime of the particle
	float decay;                          // decay speed of the particle
	float r, g, b;                          // color values of the particle
	float xpos, ypos, zpos;                 // position of the particle
	float xspeed, yspeed, zspeed;           // speed of the particle
	bool active;						  // is particle active or not?
	float deltaTimeP;


public:
	void CreateParticle();
	void EvolveParticle();


	void SetXPos(float xPos);
	void SetYPos(float yPos);
	void SetZPos(float yPos);
	void SetDeltaTime(float deltaTime);
	void SetLifeTime();
	void SetActive();

	float GetXPos();
	float GetYPos();
	float GetZPos();
	bool GetActive();
	float GetLifetime();

};